"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class VariantCall(ProtocolElement):
    """
    This is intended to hold the genotypes for the family members. This
    assumes that varinats have been split before.     In principle it
    is a phased zygosity as in VCF spec and called by the analysis
    provider if further phasing is conducted
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "participantId",
        "sampleId",
        "zygosity",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_8 import reports as reports_6_2_0

        return {
            "numberOfCopies": reports_6_2_0.NumberOfCopies,
            "phaseGenotype": reports_6_2_0.PhaseGenotype,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_8 import reports as reports_6_2_0

        return {
            "alleleOrigins": reports_6_2_0.AlleleOrigin,
            "supportingReadTypes": reports_6_2_0.SupportingReadType,
            "zygosity": reports_6_2_0.Zygosity,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_8 import reports as reports_6_2_0

        return {
            "org.gel.models.report.avro.AlleleOrigin": reports_6_2_0.AlleleOrigin,
            "org.gel.models.report.avro.NumberOfCopies": reports_6_2_0.NumberOfCopies,
            "org.gel.models.report.avro.PhaseGenotype": reports_6_2_0.PhaseGenotype,
            "org.gel.models.report.avro.SupportingReadType": reports_6_2_0.SupportingReadType,
            "org.gel.models.report.avro.Zygosity": reports_6_2_0.Zygosity,
            "org.gel.models.report.avro.VariantCall": reports_6_2_0.VariantCall,
        }

    __slots__ = [
        "participantId",
        "sampleId",
        "zygosity",
        "alleleOrigins",
        "depthAlternate",
        "depthReference",
        "numberOfCopies",
        "phaseGenotype",
        "sampleVariantAlleleFrequency",
        "supportingReadTypes",
    ]

    def __init__(
        self,
        participantId,
        sampleId,
        zygosity,
        alleleOrigins=None,
        depthAlternate=None,
        depthReference=None,
        numberOfCopies=None,
        phaseGenotype=None,
        sampleVariantAlleleFrequency=None,
        supportingReadTypes=None,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_6_2_0.VariantCall model.

        :param participantId:
            Participant id
        :type participantId: str
        :param sampleId:
            Sample Id
        :type sampleId: str
        :param zygosity:
            Zygosity. For somatic variants, or variants without zygosity use `na`
        :type zygosity: Zygosity
        :param alleleOrigins:
            Describe whether this is a somatic or Germline variant
        :type alleleOrigins: None | list[AlleleOrigin]
        :param depthAlternate:
            Depth for Alternate Allele
        :type depthAlternate: None | int
        :param depthReference:
            Depth for Reference Allele
        :type depthReference: None | int
        :param numberOfCopies:
            Alleles for copy number variation - add doc
        :type numberOfCopies: None | list[NumberOfCopies]
        :param phaseGenotype:
            phase alleles for those in phase
        :type phaseGenotype: None | PhaseGenotype
        :param sampleVariantAlleleFrequency:
            Sample Variant Allele Frequency
        :type sampleVariantAlleleFrequency: None | double
        :param supportingReadTypes:
        :type supportingReadTypes: None | list[SupportingReadType]
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "6.2.0"
